

import java.awt.*;

public class StarField extends java.applet.Applet implements Runnable
	{
	int             Width, Height;
	Thread          me = null;
	boolean         suspend = false;
	Image           im;
	Graphics        offscreen;
	double          rot, dx, ddx;

	int             speed, stars, type;
	double          defddx, max;
	Star            pol[];          /* Points of light */
	
	public void init()
		{
		rot = 0;
		dx=0;
		ddx=0;
		Width = size().width;
		Height = size().height;

		String  theSpeed = getParameter( "speed" );
		Show( "speed", theSpeed );
		speed = (theSpeed == null ) ? 50 : Integer.valueOf( theSpeed ).intValue();

		String  theStars = getParameter( "stars" );
		Show( "stars", theStars );
		stars = 500;//(theStars == null ) ? 30 : Integer.valueOf( theStars ).intValue();

		String theType = getParameter( "type" );
		Show( "type", theType );
		type = (theType == null ) ? 0 : Integer.valueOf( theType ).intValue();
	      

		String theddx = getParameter( "ddx" );
		Show( "ddx", theddx );
		defddx = (theddx == null) ? .005 : Double.valueOf( theddx ).doubleValue();

		try
			{
			im = createImage( Width, Height );
			offscreen = im.getGraphics();
			}
		catch( Exception e)
			{
			offscreen = null;
			}
		pol = new Star[stars];
		for( int i = 0; i < stars; i++ )
			pol[i] = new Star( Width, Height, 100, type );
		}

	public void paint( Graphics g )
		{
		if( offscreen != null )
			{
			paintMe( offscreen );
			g.drawImage( im, 0, 0, this );
			}
		else
			{
			paintMe( g );
			}
		}


	public void paintMe( Graphics g )
		{
		g.setColor( Color.black );
		g.fillRect( 0, 0, Width, Height );
		g.setColor( Color.gray );
		for( int i = 0; i < stars; i++ )
			pol[i].Draw( g, rot );
		}

	public void start()
		{
		if( me == null )
			{
			me = new Thread( this );
			me.start();
			}
		}

	public void stop()
		{
		if( me != null )
			{
			me.stop();
			me = null;
			}
		}

	public void run()
		{
		while( me != null )
			{
			rot += dx;
			dx += ddx;
			if( dx > max ) ddx=-defddx;
			if( dx < -max) ddx=defddx;
			try { Thread.sleep( speed ); }
			catch (InterruptedException e){}
			repaint();
			}
		}

	public void update( Graphics g )
		{
		paint( g );
		}

	public boolean mouseDown( java.awt.Event evt, int x, int y )
		{
		ddx = (ddx == 0) ? defddx : 0;
		return true;
		}

	public void Toggle( )
		{
		if( me != null )
			{
			if( suspend )
				{
				me.resume();
				}
			else
				{
				me.suspend();
				}
			suspend = !suspend;
			}
		}

	public void Show( String theString, String theValue )
		{
		if( theValue == null )
			{
			System.out.println( theString + " : null");
			}
		else
			{
			System.out.println( theString + " : " + theValue );
			}
		}
	}
